package cn.iocoder.yudao.module.system.controller.admin.biz;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.buildcleandisinfectrecord.ElderlyBuildCleanDisinfectRecordPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.buildcleandisinfectrecord.ElderlyBuildCleanDisinfectRecordRespVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.buildcleandisinfectrecord.ElderlyBuildCleanDisinfectRecordSaveReqVO;
import cn.iocoder.yudao.module.system.service.biz.ElderlyBuildCleanDisinfectRecordService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 楼栋清洁消毒记录")
@RestController
@RequestMapping("/elderly-build-clean-disinfect-record")
@Validated
public class ElderlyBuildCleanDisinfectRecordController {

    @Resource
    private ElderlyBuildCleanDisinfectRecordService elderlyBuildCleanDisinfectRecordService;

    @PostMapping("/create")
    @Operation(summary = "创建楼栋清洁消毒记录")
    public CommonResult<Long> create(@Valid @RequestBody ElderlyBuildCleanDisinfectRecordSaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(elderlyBuildCleanDisinfectRecordService.create(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "更新楼栋清洁消毒记录")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody ElderlyBuildCleanDisinfectRecordSaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        elderlyBuildCleanDisinfectRecordService.update(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除楼栋清洁消毒记录")
    @Parameter(name = "id", description = "编号", required = true)
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        elderlyBuildCleanDisinfectRecordService.delete(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得楼栋清洁消毒记录详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<ElderlyBuildCleanDisinfectRecordRespVO> get(@RequestParam("id") Long id) {
        return success(elderlyBuildCleanDisinfectRecordService.get(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得楼栋清洁消毒记录分页")
    @TenantIgnore
    public CommonResult<PageResult<ElderlyBuildCleanDisinfectRecordRespVO>> page(@Valid ElderlyBuildCleanDisinfectRecordPageReqVO pageReqVO) {
        if (pageReqVO.getTenantIds() == null) {
            pageReqVO.setTenantIds(new Long[]{TenantContextHolder.getTenantId()});
        }
        return success(elderlyBuildCleanDisinfectRecordService.getPage(pageReqVO));
    }
}
